#ifndef CANON_H
#define CANON_H

#include <QWidget>
#include <QtGui>

#include <qextserialport.h> // gestion des connexions RS232

#include "ui_canon.h" // interface graphique
#include "fenetre_rs232.h" // fenetre de configuration RS232

class CANON : public QMainWindow
{
  Q_OBJECT

// variables et fonctions
public:
  CANON(QWidget *parent = 0); // constructeur

  Ui::CANON ui; // interface graphique principale
  RS232 fenetre_rs232; // fenetre pour configurer la connexion RS232

  QextSerialPort *port; // sert a communiquer par le port serie

  // envoi et reception
  int send_rs232(QString la_commande); // envoyer vers l'appareil
  QString receive_rs232(void); // recevoir une ligne de l'appareil

  void lecture(void); // lecture des valeurs

  // les fonctions de dialogue
  QString energy(void); // Energy
  QString focus(void); // Focus
  QString sourcevoltage(void); // Source Voltage
  QString grid(void); // Grid
  QString emission(void); // Emission Current
  QString source(void); // Source Current


// les elements du UI
public slots:
  void on_pushButton_1_1_clicked();  // configuration RS232
  void on_pushButton_1_2_clicked();  // selection energy
  void on_pushButton_1_3_clicked();  // selection source voltage
  void on_pushButton_1_4_clicked();  // selection focus
  void on_pushButton_1_5_clicked();  // selection grid
  void on_pushButton_1_6_clicked();  // lecture des valeurs + connexion RS232

};

#endif
