/////////////////////////////////////////////
// energy
QString CANON::energy(void)
{
  QString valeur_retour = "-1"; // par defaut, on met a -1

  if(port == NULL) // Il y a un probleme
    return valeur_retour;        

  // envoi de gi:0
  send_rs232("gi:0");

  // reception de la valeur
  QString valeur = receive_rs232();

  // on retire gi:0
  valeur = valeur.replace("gi:0,", ""); 

  // on retire <CR> et <LF>
  valeur = valeur.replace("\x0D", ""); // on supprime les caracteres de fin
  valeur = valeur.replace("\x0A", "");

  // on fait une conversion en double
  double nombre = valeur.toDouble();
  nombre = nombre / 10; // on divise pour avoir la bonne valeur
  valeur = QString::number(nombre);

  return valeur; 
}


/////////////////////////////////////////////
// focus
QString CANON::focus(void)
{
  QString valeur_retour = "-1"; // par defaut, on met a -1

  if(port == NULL) // Il y a un probleme
    return valeur_retour;        

  // envoi de gi:4
  send_rs232("gi:4");

  // reception de la valeur
  QString valeur = receive_rs232();

  // on retire gi:4
  valeur = valeur.replace("gi:4,", ""); 

  // on retire <CR> et <LF>
  valeur = valeur.replace("\x0D", ""); // on supprime les caracteres de fin
  valeur = valeur.replace("\x0A", "");

  // on fait une conversion en double
  double nombre = valeur.toDouble();
  nombre = nombre / 10; // on divise pour avoir la bonne valeur
  valeur = QString::number(nombre);

  return valeur; 
}

/////////////////////////////////////////////
// sourcevoltage
QString CANON::sourcevoltage(void)
{
  QString valeur_retour = "-1"; // par defaut, on met a -1

  if(port == NULL) // Il y a un probleme
    return valeur_retour;        

  // envoi de gi:1
  send_rs232("gi:1");

  // reception de la valeur
  QString valeur = receive_rs232();

  // on retire gi:1
  valeur = valeur.replace("gi:1,", ""); 

  // on retire <CR> et <LF>
  valeur = valeur.replace("\x0D", ""); // on supprime les caracteres de fin
  valeur = valeur.replace("\x0A", "");

  // on fait une conversion en double
  double nombre = valeur.toDouble();
  nombre = nombre / 1000; // on divise pour avoir la bonne valeur
  valeur = QString::number(nombre);

  return valeur; 
}


/////////////////////////////////////////////
// grid
QString CANON::grid(void)
{
  QString valeur_retour = "-1"; // par defaut, on met a -1

  if(port == NULL) // Il y a un probleme
    return valeur_retour;        

  // envoi de gi:2
  send_rs232("gi:2");

  // reception de la valeur
  QString valeur = receive_rs232();

  // on retire gi:2
  valeur = valeur.replace("gi:2,", ""); 

  // on retire <CR> et <LF>
  valeur = valeur.replace("\x0D", ""); // on supprime les caracteres de fin
  valeur = valeur.replace("\x0A", "");

  // on fait une conversion en double
  double nombre = valeur.toDouble();
  nombre = nombre / 10; // on divise pour avoir la bonne valeur
  valeur = QString::number(nombre);

  return valeur; 
}


/////////////////////////////////////////////
// emission
QString CANON::emission(void)
{
  QString valeur_retour = "-1"; // par defaut, on met a -1

  if(port == NULL) // Il y a un probleme
    return valeur_retour;        

  // envoi de gi:10
  send_rs232("gi:10");

  // reception de la valeur
  QString valeur = receive_rs232();

  // on retire gi:10
  valeur = valeur.replace("gi:10,", ""); 

  // on retire <CR> et <LF>
  valeur = valeur.replace("\x0D", ""); // on supprime les caracteres de fin
  valeur = valeur.replace("\x0A", "");

  // on fait une conversion en double
  double nombre = valeur.toDouble();
  nombre = nombre / 10; // on divise pour avoir la bonne valeur
  valeur = QString::number(nombre);

  return valeur; 
}

/////////////////////////////////////////////
// source
QString CANON::source(void)
{
  QString valeur_retour = "-1"; // par defaut, on met a -1

  if(port == NULL) // Il y a un probleme
    return valeur_retour;        

  // envoi de gi:11
  send_rs232("gi:11");

  // reception de la valeur
  QString valeur = receive_rs232();

  // on retire gi:11
  valeur = valeur.replace("gi:11,", ""); 

  // on retire <CR> et <LF>
  valeur = valeur.replace("\x0D", ""); // on supprime les caracteres de fin
  valeur = valeur.replace("\x0A", "");

  // on fait une conversion en double
  double nombre = valeur.toDouble();
  nombre = nombre / 1000; // on divise pour avoir la bonne valeur
  valeur = QString::number(nombre);

  return valeur; 
}
