/////////////////////////////////////////////
// Envoyer vers l'appareil
int CANON::send_rs232(QString la_commande)
{
  int valeur_retour = 0; // par defaut, on met a 0

  if(port == NULL)
  {
    valeur_retour = -1; // Il y a un probleme
    return valeur_retour;        
  }

  // envoi de la commande + <LF> + <CR>
  QString commande = la_commande + "\x0D" + "\x0A";
  QByteArray commandeByte = commande.toAscii();
  int i = port->write(commandeByte);

  port->flush();

  if(i != commande.length())
    valeur_retour = -1; // il y a un probleme

  return valeur_retour; // 0 = tout va bien et -1 = probleme
}


/////////////////////////////////////////////
// Recevoir de l'appareil
QString CANON::receive_rs232(void)
{
  if(port == NULL)
  {
    return "";
  }


  for(int xyz = 0 ; xyz < 30; xyz++)
  {
    // on regarde s'il y a quelque chose a recuperer
    if( port->bytesAvailable() == 0 && port->size() == 0 && port->atEnd() == 0)
    {
      // on laise un delai pour voir si on ne recoit vraiment rien
      // Sleep(10); // 10 ms d'attente
      QEventLoop evtLoop;
      QTimer::singleShot(10, &evtLoop, SLOT(quit())); // 10 ms d'attente
      evtLoop.exec();
    }
    else
      break;
  }

  if( port->bytesAvailable() == 0 && port->size() == 0 && port->atEnd() == 0) 
  {
    return "";
  }


  // lecture d'une ligne
  char tableau[201];
  int i = port->readLine ( tableau, 200);  
  if( i > 0) // c'est bon
    tableau[i] = '\0'; // on ferme le texte
  else // pas bon
  {
    return "";
  }

  
  QString la_commande = tableau;

  for(int xyz = 0 ; xyz < 30; xyz++)
  {
    // tester le dernier caractere de la chaine recue
    if( la_commande.contains("\x0A") == TRUE ) // on est arrive au bout de la phrase
      break;
    else if( la_commande.contains("\x0A") == FALSE ) // on etait pas arrive au bout de la phrase
    {
      //    affichage_moniteur("Le mot etait incomplet  !! reception a nouveau", 1, 0);
      // on laise un delai pour voir si on ne recoit vraiment rien
      // Sleep(10); // 10 ms d'attente
      QEventLoop evtLoop;
      QTimer::singleShot(10, &evtLoop, SLOT(quit())); // 10 ms d'attente
      evtLoop.exec();

      if( port->bytesAvailable() != 0) 
      {
        i = port->readLine ( tableau, 200);  
        if( i > 0) // c'est bon
        {
          tableau[i] = '\0'; // on ferme le texte
          la_commande = la_commande + tableau;
        }
      }
    }
  }

  return la_commande; 
}

